/* application.c generated by valac 0.56.4, the Vala compiler
 * generated from application.vala, do not modify */

/* application.vala
 *
 * Copyright 2023 Link Dupont <link@sub-pop.net>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <json-glib/json-glib.h>

#define VERSION "0.1.0"
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_MESSAGE (message_get_type ())
#define MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_MESSAGE, Message))
#define MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_MESSAGE, MessageClass))
#define IS_MESSAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_MESSAGE))
#define IS_MESSAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_MESSAGE))
#define MESSAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_MESSAGE, MessageClass))

typedef struct _Message Message;
typedef struct _MessageClass MessageClass;
typedef struct _MessagePrivate MessagePrivate;
enum  {
	MESSAGE_0_PROPERTY,
	MESSAGE_TITLE_PROPERTY,
	MESSAGE_BODY_PROPERTY,
	MESSAGE_NUM_PROPERTIES
};
static GParamSpec* message_properties[MESSAGE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_APPLICATION (application_get_type ())
#define APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_APPLICATION, Application))
#define APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_APPLICATION, ApplicationClass))
#define IS_APPLICATION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_APPLICATION))
#define IS_APPLICATION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_APPLICATION))
#define APPLICATION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_APPLICATION, ApplicationClass))

typedef struct _Application Application;
typedef struct _ApplicationClass ApplicationClass;
typedef struct _ApplicationPrivate ApplicationPrivate;
enum  {
	APPLICATION_0_PROPERTY,
	APPLICATION_REMOTE_CONTENT_PROPERTY,
	APPLICATION_FEATURES_PROPERTY,
	APPLICATION_NUM_PROPERTIES
};
static GParamSpec* application_properties[APPLICATION_NUM_PROPERTIES];
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _Message {
	GObject parent_instance;
	MessagePrivate * priv;
};

struct _MessageClass {
	GObjectClass parent_class;
};

struct _MessagePrivate {
	gchar* _title;
	gchar* _body;
};

struct _Application {
	GApplication parent_instance;
	ApplicationPrivate * priv;
};

struct _ApplicationClass {
	GApplicationClass parent_class;
};

struct _ApplicationPrivate {
	guint object_id;
	GHashTable* _features;
};

static gint Message_private_offset;
static gpointer message_parent_class = NULL;
static gint Application_private_offset;
static gpointer application_parent_class = NULL;

VALA_EXTERN GType message_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Message, g_object_unref)
VALA_EXTERN Message* message_new (void);
VALA_EXTERN Message* message_construct (GType object_type);
VALA_EXTERN const gchar* message_get_title (Message* self);
VALA_EXTERN void message_set_title (Message* self,
                        const gchar* value);
VALA_EXTERN const gchar* message_get_body (Message* self);
VALA_EXTERN void message_set_body (Message* self,
                       const gchar* value);
static void message_finalize (GObject * obj);
static GType message_get_type_once (void);
static void _vala_message_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec);
static void _vala_message_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec);
VALA_EXTERN GType application_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Application, g_object_unref)
VALA_EXTERN guint application_register_object (void* object,
                                   GDBusConnection* connection,
                                   const gchar* path,
                                   GError** error);
static void _g_free0_ (gpointer var);
VALA_EXTERN Application* application_new (void);
VALA_EXTERN Application* application_construct (GType object_type);
static void application_real_activate (GApplication* base);
static gboolean application_real_dbus_register (GApplication* base,
                                         GDBusConnection* connection,
                                         const gchar* object_path,
                                         GError** error);
static void application_real_dbus_unregister (GApplication* base,
                                       GDBusConnection* connection,
                                       const gchar* object_path);
VALA_EXTERN void application_dispatch (Application* self,
                           const gchar* addr,
                           const gchar* id,
                           const gchar* response_to,
                           GHashTable* metadata,
                           gchar* data,
                           gint data_length1,
                           GError** error);
VALA_EXTERN gboolean application_get_remote_content (Application* self);
VALA_EXTERN GHashTable* application_get_features (Application* self);
static GObject * application_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void application_finalize (GObject * obj);
static GType application_get_type_once (void);
static void _vala_application_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _dbus_application_dispatch (Application* self,
                                 GVariant* _parameters_,
                                 GDBusMethodInvocation* invocation);
static void application_dbus_interface_method_call (GDBusConnection* connection,
                                             const gchar* sender,
                                             const gchar* object_path,
                                             const gchar* interface_name,
                                             const gchar* method_name,
                                             GVariant* parameters,
                                             GDBusMethodInvocation* invocation,
                                             gpointer user_data);
static GVariant* application_dbus_interface_get_property (GDBusConnection* connection,
                                                   const gchar* sender,
                                                   const gchar* object_path,
                                                   const gchar* interface_name,
                                                   const gchar* property_name,
                                                   GError** error,
                                                   gpointer user_data);
static GVariant* _dbus_application_get_remote_content (Application* self);
static GVariant* _dbus_application_get_features (Application* self);
static gboolean application_dbus_interface_set_property (GDBusConnection* connection,
                                                  const gchar* sender,
                                                  const gchar* object_path,
                                                  const gchar* interface_name,
                                                  const gchar* property_name,
                                                  GVariant* value,
                                                  GError** error,
                                                  gpointer user_data);
static void _application_unregister_object (gpointer user_data);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusArgInfo _application_dbus_arg_info_dispatch_addr = {-1, "addr", "s", NULL};
static const GDBusArgInfo _application_dbus_arg_info_dispatch_id = {-1, "id", "s", NULL};
static const GDBusArgInfo _application_dbus_arg_info_dispatch_response_to = {-1, "response_to", "s", NULL};
static const GDBusArgInfo _application_dbus_arg_info_dispatch_metadata = {-1, "metadata", "a{ss}", NULL};
static const GDBusArgInfo _application_dbus_arg_info_dispatch_data = {-1, "data", "ay", NULL};
static const GDBusArgInfo * const _application_dbus_arg_info_dispatch_in[] = {&_application_dbus_arg_info_dispatch_addr, &_application_dbus_arg_info_dispatch_id, &_application_dbus_arg_info_dispatch_response_to, &_application_dbus_arg_info_dispatch_metadata, &_application_dbus_arg_info_dispatch_data, NULL};
static const GDBusArgInfo * const _application_dbus_arg_info_dispatch_out[] = {NULL};
static const GDBusMethodInfo _application_dbus_method_info_dispatch = {-1, "Dispatch", (GDBusArgInfo **) (&_application_dbus_arg_info_dispatch_in), (GDBusArgInfo **) (&_application_dbus_arg_info_dispatch_out), NULL};
static const GDBusMethodInfo * const _application_dbus_method_info[] = {&_application_dbus_method_info_dispatch, NULL};
static const GDBusSignalInfo * const _application_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _application_dbus_property_info_remote_content = {-1, "RemoteContent", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo _application_dbus_property_info_features = {-1, "Features", "a{ss}", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _application_dbus_property_info[] = {&_application_dbus_property_info_remote_content, &_application_dbus_property_info_features, NULL};
static const GDBusInterfaceInfo _application_dbus_interface_info = {-1, "com.redhat.Yggdrasil1.Worker1", (GDBusMethodInfo **) (&_application_dbus_method_info), (GDBusSignalInfo **) (&_application_dbus_signal_info), (GDBusPropertyInfo **) (&_application_dbus_property_info), NULL};
static const GDBusInterfaceVTable _application_dbus_interface_vtable = {application_dbus_interface_method_call, application_dbus_interface_get_property, application_dbus_interface_set_property};

static inline gpointer
message_get_instance_private (Message* self)
{
	return G_STRUCT_MEMBER_P (self, Message_private_offset);
}

Message*
message_construct (GType object_type)
{
	Message * self = NULL;
#line 21 "../src/application.vala"
	self = (Message*) g_object_new (object_type, NULL);
#line 21 "../src/application.vala"
	return self;
#line 233 "application.c"
}

Message*
message_new (void)
{
#line 21 "../src/application.vala"
	return message_construct (TYPE_MESSAGE);
#line 241 "application.c"
}

const gchar*
message_get_title (Message* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 22 "../src/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 22 "../src/application.vala"
	_tmp0_ = self->priv->_title;
#line 22 "../src/application.vala"
	result = _tmp0_;
#line 22 "../src/application.vala"
	return result;
#line 257 "application.c"
}

void
message_set_title (Message* self,
                   const gchar* value)
{
	gchar* old_value;
#line 22 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 22 "../src/application.vala"
	old_value = message_get_title (self);
#line 22 "../src/application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 271 "application.c"
		gchar* _tmp0_;
#line 22 "../src/application.vala"
		_tmp0_ = g_strdup (value);
#line 22 "../src/application.vala"
		_g_free0 (self->priv->_title);
#line 22 "../src/application.vala"
		self->priv->_title = _tmp0_;
#line 22 "../src/application.vala"
		g_object_notify_by_pspec ((GObject *) self, message_properties[MESSAGE_TITLE_PROPERTY]);
#line 281 "application.c"
	}
}

const gchar*
message_get_body (Message* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 23 "../src/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 23 "../src/application.vala"
	_tmp0_ = self->priv->_body;
#line 23 "../src/application.vala"
	result = _tmp0_;
#line 23 "../src/application.vala"
	return result;
#line 298 "application.c"
}

void
message_set_body (Message* self,
                  const gchar* value)
{
	gchar* old_value;
#line 23 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 23 "../src/application.vala"
	old_value = message_get_body (self);
#line 23 "../src/application.vala"
	if (g_strcmp0 (value, old_value) != 0) {
#line 312 "application.c"
		gchar* _tmp0_;
#line 23 "../src/application.vala"
		_tmp0_ = g_strdup (value);
#line 23 "../src/application.vala"
		_g_free0 (self->priv->_body);
#line 23 "../src/application.vala"
		self->priv->_body = _tmp0_;
#line 23 "../src/application.vala"
		g_object_notify_by_pspec ((GObject *) self, message_properties[MESSAGE_BODY_PROPERTY]);
#line 322 "application.c"
	}
}

static void
message_class_init (MessageClass * klass,
                    gpointer klass_data)
{
#line 21 "../src/application.vala"
	message_parent_class = g_type_class_peek_parent (klass);
#line 21 "../src/application.vala"
	g_type_class_adjust_private_offset (klass, &Message_private_offset);
#line 21 "../src/application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_message_get_property;
#line 21 "../src/application.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_message_set_property;
#line 21 "../src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = message_finalize;
#line 21 "../src/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MESSAGE_TITLE_PROPERTY, message_properties[MESSAGE_TITLE_PROPERTY] = g_param_spec_string ("title", "title", "title", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 21 "../src/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), MESSAGE_BODY_PROPERTY, message_properties[MESSAGE_BODY_PROPERTY] = g_param_spec_string ("body", "body", "body", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 344 "application.c"
}

static void
message_instance_init (Message * self,
                       gpointer klass)
{
#line 21 "../src/application.vala"
	self->priv = message_get_instance_private (self);
#line 353 "application.c"
}

static void
message_finalize (GObject * obj)
{
	Message * self;
#line 21 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_MESSAGE, Message);
#line 22 "../src/application.vala"
	_g_free0 (self->priv->_title);
#line 23 "../src/application.vala"
	_g_free0 (self->priv->_body);
#line 21 "../src/application.vala"
	G_OBJECT_CLASS (message_parent_class)->finalize (obj);
#line 368 "application.c"
}

 G_GNUC_NO_INLINE static GType
message_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (MessageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) message_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Message), 0, (GInstanceInitFunc) message_instance_init, NULL };
	GType message_type_id;
	message_type_id = g_type_register_static (G_TYPE_OBJECT, "Message", &g_define_type_info, 0);
	Message_private_offset = g_type_add_instance_private (message_type_id, sizeof (MessagePrivate));
	return message_type_id;
}

GType
message_get_type (void)
{
	static volatile gsize message_type_id__once = 0;
	if (g_once_init_enter (&message_type_id__once)) {
		GType message_type_id;
		message_type_id = message_get_type_once ();
		g_once_init_leave (&message_type_id__once, message_type_id);
	}
	return message_type_id__once;
}

static void
_vala_message_get_property (GObject * object,
                            guint property_id,
                            GValue * value,
                            GParamSpec * pspec)
{
	Message * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MESSAGE, Message);
#line 21 "../src/application.vala"
	switch (property_id) {
#line 21 "../src/application.vala"
		case MESSAGE_TITLE_PROPERTY:
#line 21 "../src/application.vala"
		g_value_set_string (value, message_get_title (self));
#line 21 "../src/application.vala"
		break;
#line 21 "../src/application.vala"
		case MESSAGE_BODY_PROPERTY:
#line 21 "../src/application.vala"
		g_value_set_string (value, message_get_body (self));
#line 21 "../src/application.vala"
		break;
#line 415 "application.c"
		default:
#line 21 "../src/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/application.vala"
		break;
#line 421 "application.c"
	}
}

static void
_vala_message_set_property (GObject * object,
                            guint property_id,
                            const GValue * value,
                            GParamSpec * pspec)
{
	Message * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_MESSAGE, Message);
#line 21 "../src/application.vala"
	switch (property_id) {
#line 21 "../src/application.vala"
		case MESSAGE_TITLE_PROPERTY:
#line 21 "../src/application.vala"
		message_set_title (self, g_value_get_string (value));
#line 21 "../src/application.vala"
		break;
#line 21 "../src/application.vala"
		case MESSAGE_BODY_PROPERTY:
#line 21 "../src/application.vala"
		message_set_body (self, g_value_get_string (value));
#line 21 "../src/application.vala"
		break;
#line 447 "application.c"
		default:
#line 21 "../src/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 21 "../src/application.vala"
		break;
#line 453 "application.c"
	}
}

static inline gpointer
application_get_instance_private (Application* self)
{
	return G_STRUCT_MEMBER_P (self, Application_private_offset);
}

static void
_g_free0_ (gpointer var)
{
#line 29 "../src/application.vala"
	var = (g_free (var), NULL);
#line 468 "application.c"
}

Application*
application_construct (GType object_type)
{
	Application * self = NULL;
#line 42 "../src/application.vala"
	self = (Application*) g_object_new (object_type, "application-id", "com.redhat.Yggdrasil1.Worker1.desktop_notification", NULL);
#line 41 "../src/application.vala"
	return self;
#line 479 "application.c"
}

Application*
application_new (void)
{
#line 41 "../src/application.vala"
	return application_construct (TYPE_APPLICATION);
#line 487 "application.c"
}

static void
application_real_activate (GApplication* base)
{
	Application * self;
#line 49 "../src/application.vala"
	self = (Application*) base;
#line 50 "../src/application.vala"
	g_application_hold ((GApplication*) self);
#line 498 "application.c"
}

static gboolean
application_real_dbus_register (GApplication* base,
                                GDBusConnection* connection,
                                const gchar* object_path,
                                GError** error)
{
	Application * self;
	guint _tmp1_ = 0U;
	guint _tmp2_;
	GError* _inner_error0_ = NULL;
	gboolean result;
#line 53 "../src/application.vala"
	self = (Application*) base;
#line 53 "../src/application.vala"
	g_return_val_if_fail (connection != NULL, FALSE);
#line 53 "../src/application.vala"
	g_return_val_if_fail (object_path != NULL, FALSE);
#line 54 "../src/application.vala"
	G_APPLICATION_CLASS (application_parent_class)->dbus_register (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication), connection, object_path, &_inner_error0_);
#line 54 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 522 "application.c"
		gboolean _tmp0_ = FALSE;
#line 54 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 54 "../src/application.vala"
		return _tmp0_;
#line 528 "application.c"
	}
#line 55 "../src/application.vala"
	_tmp2_ = application_register_object (self, connection, object_path, &_inner_error0_);
#line 55 "../src/application.vala"
	_tmp1_ = _tmp2_;
#line 55 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 536 "application.c"
		gboolean _tmp3_ = FALSE;
#line 55 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 55 "../src/application.vala"
		return _tmp3_;
#line 542 "application.c"
	}
#line 55 "../src/application.vala"
	self->priv->object_id = _tmp1_;
#line 56 "../src/application.vala"
	result = TRUE;
#line 56 "../src/application.vala"
	return result;
#line 550 "application.c"
}

static void
application_real_dbus_unregister (GApplication* base,
                                  GDBusConnection* connection,
                                  const gchar* object_path)
{
	Application * self;
#line 59 "../src/application.vala"
	self = (Application*) base;
#line 59 "../src/application.vala"
	g_return_if_fail (connection != NULL);
#line 59 "../src/application.vala"
	g_return_if_fail (object_path != NULL);
#line 60 "../src/application.vala"
	G_APPLICATION_CLASS (application_parent_class)->dbus_unregister (G_TYPE_CHECK_INSTANCE_CAST (self, g_application_get_type (), GApplication), connection, object_path);
#line 567 "application.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 66 "../src/application.vala"
	return self ? g_object_ref (self) : NULL;
#line 575 "application.c"
}

void
application_dispatch (Application* self,
                      const gchar* addr,
                      const gchar* id,
                      const gchar* response_to,
                      GHashTable* metadata,
                      gchar* data,
                      gint data_length1,
                      GError** error)
{
	GObject* _tmp0_ = NULL;
	GObject* _tmp1_;
	Message* message = NULL;
	Message* _tmp2_;
	GNotification* notification = NULL;
	Message* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GNotification* _tmp6_;
	Message* _tmp7_;
	const gchar* _tmp8_;
	const gchar* _tmp9_;
	GIcon* icon = NULL;
	GThemedIcon* _tmp14_;
	GNotification* _tmp15_;
	GIcon* _tmp16_;
	GNotification* _tmp17_;
	GError* _inner_error0_ = NULL;
#line 64 "../src/application.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/application.vala"
	g_return_if_fail (addr != NULL);
#line 64 "../src/application.vala"
	g_return_if_fail (id != NULL);
#line 64 "../src/application.vala"
	g_return_if_fail (response_to != NULL);
#line 64 "../src/application.vala"
	g_return_if_fail (metadata != NULL);
#line 65 "../src/application.vala"
	g_debug ("application.vala:65: %s", (const gchar*) data);
#line 66 "../src/application.vala"
	_tmp1_ = json_gobject_from_data (TYPE_MESSAGE, (const gchar*) data, (gssize) -1, &_inner_error0_);
#line 66 "../src/application.vala"
	_tmp0_ = _tmp1_;
#line 66 "../src/application.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 66 "../src/application.vala"
		g_propagate_error (error, _inner_error0_);
#line 66 "../src/application.vala"
		return;
#line 628 "application.c"
	}
#line 66 "../src/application.vala"
	_tmp2_ = _g_object_ref0 (IS_MESSAGE (_tmp0_) ? ((Message*) _tmp0_) : NULL);
#line 66 "../src/application.vala"
	message = _tmp2_;
#line 67 "../src/application.vala"
	_tmp3_ = message;
#line 67 "../src/application.vala"
	_tmp4_ = message_get_title (_tmp3_);
#line 67 "../src/application.vala"
	_tmp5_ = _tmp4_;
#line 67 "../src/application.vala"
	_tmp6_ = g_notification_new (_tmp5_);
#line 67 "../src/application.vala"
	notification = _tmp6_;
#line 68 "../src/application.vala"
	_tmp7_ = message;
#line 68 "../src/application.vala"
	_tmp8_ = message_get_body (_tmp7_);
#line 68 "../src/application.vala"
	_tmp9_ = _tmp8_;
#line 68 "../src/application.vala"
	if (_tmp9_ != NULL) {
#line 652 "application.c"
		GNotification* _tmp10_;
		Message* _tmp11_;
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 69 "../src/application.vala"
		_tmp10_ = notification;
#line 69 "../src/application.vala"
		_tmp11_ = message;
#line 69 "../src/application.vala"
		_tmp12_ = message_get_body (_tmp11_);
#line 69 "../src/application.vala"
		_tmp13_ = _tmp12_;
#line 69 "../src/application.vala"
		g_notification_set_body (_tmp10_, _tmp13_);
#line 667 "application.c"
	}
#line 71 "../src/application.vala"
	_tmp14_ = (GThemedIcon*) g_themed_icon_new ("dialog-information-symbolic");
#line 71 "../src/application.vala"
	icon = (GIcon*) _tmp14_;
#line 72 "../src/application.vala"
	_tmp15_ = notification;
#line 72 "../src/application.vala"
	_tmp16_ = icon;
#line 72 "../src/application.vala"
	g_notification_set_icon (_tmp15_, _tmp16_);
#line 73 "../src/application.vala"
	_tmp17_ = notification;
#line 73 "../src/application.vala"
	g_application_send_notification ((GApplication*) self, id, _tmp17_);
#line 64 "../src/application.vala"
	_g_object_unref0 (icon);
#line 64 "../src/application.vala"
	_g_object_unref0 (notification);
#line 64 "../src/application.vala"
	_g_object_unref0 (message);
#line 64 "../src/application.vala"
	_g_object_unref0 (_tmp0_);
#line 691 "application.c"
}

gboolean
application_get_remote_content (Application* self)
{
	gboolean result;
#line 32 "../src/application.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/application.vala"
	result = FALSE;
#line 32 "../src/application.vala"
	return result;
#line 704 "application.c"
}

GHashTable*
application_get_features (Application* self)
{
	GHashTable* result;
	GHashTable* _tmp0_;
#line 36 "../src/application.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/application.vala"
	_tmp0_ = self->priv->_features;
#line 37 "../src/application.vala"
	result = _tmp0_;
#line 37 "../src/application.vala"
	return result;
#line 720 "application.c"
}

static GObject *
application_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Application * self;
	GHashTable* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 45 "../src/application.vala"
	parent_class = G_OBJECT_CLASS (application_parent_class);
#line 45 "../src/application.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 45 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION, Application);
#line 46 "../src/application.vala"
	_tmp0_ = self->priv->_features;
#line 46 "../src/application.vala"
	_tmp1_ = g_strdup ("version");
#line 46 "../src/application.vala"
	_tmp2_ = g_strdup (VERSION);
#line 46 "../src/application.vala"
	g_hash_table_insert (_tmp0_, _tmp1_, _tmp2_);
#line 45 "../src/application.vala"
	return obj;
#line 750 "application.c"
}

static void
application_class_init (ApplicationClass * klass,
                        gpointer klass_data)
{
#line 27 "../src/application.vala"
	application_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/application.vala"
	g_type_class_adjust_private_offset (klass, &Application_private_offset);
#line 27 "../src/application.vala"
	((GApplicationClass *) klass)->activate = (void (*) (GApplication*)) application_real_activate;
#line 27 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_register = (gboolean (*) (GApplication*, GDBusConnection*, const gchar*, GError**)) application_real_dbus_register;
#line 27 "../src/application.vala"
	((GApplicationClass *) klass)->dbus_unregister = (void (*) (GApplication*, GDBusConnection*, const gchar*)) application_real_dbus_unregister;
#line 27 "../src/application.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_application_get_property;
#line 27 "../src/application.vala"
	G_OBJECT_CLASS (klass)->constructor = application_constructor;
#line 27 "../src/application.vala"
	G_OBJECT_CLASS (klass)->finalize = application_finalize;
#line 27 "../src/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_REMOTE_CONTENT_PROPERTY, application_properties[APPLICATION_REMOTE_CONTENT_PROPERTY] = g_param_spec_boolean ("remote-content", "remote-content", "remote-content", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 27 "../src/application.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), APPLICATION_FEATURES_PROPERTY, application_properties[APPLICATION_FEATURES_PROPERTY] = g_param_spec_boxed ("features", "features", "features", G_TYPE_HASH_TABLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 777 "application.c"
}

static void
application_instance_init (Application * self,
                           gpointer klass)
{
	GHashFunc _tmp0_;
	GEqualFunc _tmp1_;
	GHashTable* _tmp2_;
#line 27 "../src/application.vala"
	self->priv = application_get_instance_private (self);
#line 29 "../src/application.vala"
	_tmp0_ = g_str_hash;
#line 29 "../src/application.vala"
	_tmp1_ = g_str_equal;
#line 29 "../src/application.vala"
	_tmp2_ = g_hash_table_new_full (_tmp0_, _tmp1_, _g_free0_, _g_free0_);
#line 29 "../src/application.vala"
	self->priv->_features = _tmp2_;
#line 797 "application.c"
}

static void
application_finalize (GObject * obj)
{
	Application * self;
#line 27 "../src/application.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_APPLICATION, Application);
#line 29 "../src/application.vala"
	_g_hash_table_unref0 (self->priv->_features);
#line 27 "../src/application.vala"
	G_OBJECT_CLASS (application_parent_class)->finalize (obj);
#line 810 "application.c"
}

 G_GNUC_NO_INLINE static GType
application_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ApplicationClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) application_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Application), 0, (GInstanceInitFunc) application_instance_init, NULL };
	GType application_type_id;
	application_type_id = g_type_register_static (g_application_get_type (), "Application", &g_define_type_info, 0);
	g_type_set_qdata (application_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) application_register_object);
	Application_private_offset = g_type_add_instance_private (application_type_id, sizeof (ApplicationPrivate));
	return application_type_id;
}

GType
application_get_type (void)
{
	static volatile gsize application_type_id__once = 0;
	if (g_once_init_enter (&application_type_id__once)) {
		GType application_type_id;
		application_type_id = application_get_type_once ();
		g_once_init_leave (&application_type_id__once, application_type_id);
	}
	return application_type_id__once;
}

static void
_vala_application_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	Application * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_APPLICATION, Application);
#line 27 "../src/application.vala"
	switch (property_id) {
#line 27 "../src/application.vala"
		case APPLICATION_REMOTE_CONTENT_PROPERTY:
#line 27 "../src/application.vala"
		g_value_set_boolean (value, application_get_remote_content (self));
#line 27 "../src/application.vala"
		break;
#line 27 "../src/application.vala"
		case APPLICATION_FEATURES_PROPERTY:
#line 27 "../src/application.vala"
		g_value_set_boxed (value, application_get_features (self));
#line 27 "../src/application.vala"
		break;
#line 858 "application.c"
		default:
#line 27 "../src/application.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 27 "../src/application.vala"
		break;
#line 864 "application.c"
	}
}

static void
_dbus_application_dispatch (Application* self,
                            GVariant* _parameters_,
                            GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* addr = NULL;
	GVariant* _tmp0_;
	gchar* id = NULL;
	GVariant* _tmp1_;
	gchar* response_to = NULL;
	GVariant* _tmp2_;
	GHashTable* metadata = NULL;
	GVariant* _tmp3_;
	GHashTable* _tmp4_;
	GVariantIter _tmp5_;
	GVariant* _tmp6_;
	GVariant* _tmp7_;
	gchar* data = NULL;
	gint data_length1 = 0;
	GVariant* _tmp8_;
	gsize _tmp9__length;
	gchar* _tmp9_;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, _parameters_);
	_tmp0_ = g_variant_iter_next_value (&_arguments_iter);
	addr = g_variant_dup_string (_tmp0_, NULL);
	g_variant_unref (_tmp0_);
	_tmp1_ = g_variant_iter_next_value (&_arguments_iter);
	id = g_variant_dup_string (_tmp1_, NULL);
	g_variant_unref (_tmp1_);
	_tmp2_ = g_variant_iter_next_value (&_arguments_iter);
	response_to = g_variant_dup_string (_tmp2_, NULL);
	g_variant_unref (_tmp2_);
	_tmp3_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp4_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
	g_variant_iter_init (&_tmp5_, _tmp3_);
	while (g_variant_iter_loop (&_tmp5_, "{?*}", &_tmp6_, &_tmp7_)) {
		g_hash_table_insert (_tmp4_, g_variant_dup_string (_tmp6_, NULL), g_variant_dup_string (_tmp7_, NULL));
	}
	metadata = _tmp4_;
	g_variant_unref (_tmp3_);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	_tmp9__length = g_variant_get_size (_tmp8_);
	_tmp9_ = _vala_memdup2 (g_variant_get_data (_tmp8_), _tmp9__length);
	data_length1 = _tmp9__length;
	data = _tmp9_;
	g_variant_unref (_tmp8_);
	application_dispatch (self, addr, id, response_to, metadata, data, data_length1, &error);
	if (error) {
		g_dbus_method_invocation_take_error (invocation, error);
		goto _error;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
	_error:
	_g_free0 (addr);
	_g_free0 (id);
	_g_free0 (response_to);
	_g_hash_table_unref0 (metadata);
	data = (g_free (data), NULL);
	;
}

static void
application_dbus_interface_method_call (GDBusConnection* connection,
                                        const gchar* sender,
                                        const gchar* object_path,
                                        const gchar* interface_name,
                                        const gchar* method_name,
                                        GVariant* parameters,
                                        GDBusMethodInvocation* invocation,
                                        gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Dispatch") == 0) {
		_dbus_application_dispatch (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}

static GVariant*
_dbus_application_get_remote_content (Application* self)
{
	gboolean result;
	GVariant* _reply;
	result = application_get_remote_content (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
_dbus_application_get_features (Application* self)
{
	GHashTable* result;
	GVariant* _reply;
	GVariantBuilder _tmp10_;
	GHashTableIter _tmp11_;
	gpointer _tmp12_;
	gpointer _tmp13_;
	result = application_get_features (self);
	g_hash_table_iter_init (&_tmp11_, result);
	g_variant_builder_init (&_tmp10_, G_VARIANT_TYPE ("a{ss}"));
	while (g_hash_table_iter_next (&_tmp11_, &_tmp12_, &_tmp13_)) {
		gchar* _key;
		gchar* _value;
		_key = (gchar*) _tmp12_;
		_value = (gchar*) _tmp13_;
		g_variant_builder_add (&_tmp10_, "{?*}", g_variant_new_string (_key), g_variant_new_string (_value));
	}
	_reply = g_variant_builder_end (&_tmp10_);
	return _reply;
}

static GVariant*
application_dbus_interface_get_property (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* property_name,
                                         GError** error,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "RemoteContent") == 0) {
		return _dbus_application_get_remote_content (object);
	} else if (strcmp (property_name, "Features") == 0) {
		return _dbus_application_get_features (object);
	}
	return NULL;
}

static gboolean
application_dbus_interface_set_property (GDBusConnection* connection,
                                         const gchar* sender,
                                         const gchar* object_path,
                                         const gchar* interface_name,
                                         const gchar* property_name,
                                         GVariant* value,
                                         GError** error,
                                         gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

guint
application_register_object (gpointer object,
                             GDBusConnection* connection,
                             const gchar* path,
                             GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_application_dbus_interface_info), &_application_dbus_interface_vtable, data, _application_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_application_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

